#include <inttypes.h>
#include <avr/io.h>
#include <avr/pgmspace.h>
#include "i2c.h"

#define I2C_START 0x08
#define I2C_START_RPT 0x10
#define I2C_SLA_W_ACK 0x18
#define I2C_SLA_R_ACK 0x40
#define I2C_DATA_ACK 0x28
#define SAddr  0b11100100
#define SAddr_1  0b11100101






uint8_t i2cStart(void)
{
	TWCR = (1<<TWINT) | (1<<TWSTA) | (1<<TWEN); //    TWCR  , 
	                                              //  "".

	while (!(TWCR & (1<<TWINT))) ;              //    TWINT   

	return (TWSR & 0xF8);                        //     TWSR  .  
}

void i2cStop(void)
{
	TWCR = (1<<TWINT) | (1<<TWEN) | (1<<TWSTO); //    TWCR  , 
	                                              //  "".
		while ((TWCR & (1<<TWSTO))) ;
}

uint8_t i2cByteSend(uint8_t data)                 //  
{
	TWDR = data;                                  //     TWDR

	TWCR = (1<<TWINT) | (1<<TWEN);               //      
	                                              // 

	while (!(TWCR & (1<<TWINT))) ;               //    TWINT   TWCR.

	return (TWSR & 0xF8);                         //      
}


uint8_t i2c_eep_WriteByte(uint8_t reg_1, uint8_t reg) 

{ 

 
	i2cStart();                        //	

	i2cByteSend(SAddr);                //  

	i2cByteSend(0x01);                 //  -        

	i2cByteSend(reg_1);                //    
	
	i2cStop();                         // 	
	
	i2cStart();                        // 
	
	i2cByteSend(SAddr);                //  
		
	i2cByteSend(reg);                  //  -        
	
	
    return 2;
}

char  WriteByte(char reg_3, char reg_4, char date) //  ,   : WriteByte (page[k], reg_a[k], date_1[k]); 

{ 
 
 
	i2cStart();                        //	

	i2cByteSend(SAddr);                //  

	i2cByteSend(0x01);                 //  -        

	i2cByteSend(reg_3);                //    
	
	i2cStop();                         // 	
	
	i2cStart();                        // 
	
	i2cByteSend(SAddr);                //  
		
	i2cByteSend(reg_4);                //  -        
	
	i2cByteSend(date);                 //(   ClockBuilder Pro)
	
     i2cStop(); 
	 
	 return 2;
}


/******************** Init TWI (I2C)   *******************************************/

void i2cInit()
{
	TWBR = 92;	                                         //   					
	TWSR = 0;
	TWDR = 0xFF;
	PRR = 0;
}
