#ifndef I2C_H
#define I2C_H

#include <inttypes.h>
#include <avr/io.h>
#include <avr/pgmspace.h>

#define SAddr 0b11101000

#include <inttypes.h>
#include <util/twi.h>		

void i2cInit(void);
 uint8_t i2cSendRegister(uint8_t, uint8_t);
  uint8_t i2c_eep_WriteByte(uint8_t, uint8_t);


uint8_t i2cStart(void)
{
	TWCR = (1<<TWINT) | (1<<TWSTA) | (1<<TWEN); //    TWCR  , 
	                                              //  "".

	while (!(TWCR & (1<<TWINT))) ;              //    TWINT   
	return 0;  
}

void i2cStop(void)
{
	TWCR = (1<<TWINT) | (1<<TWEN) | (1<<TWSTO); //    TWCR  ,  "".	

	  while ((TWCR & (1<<TWSTO))) ;
}

uint8_t i2cByteSend(uint8_t data)                 //  
{
	TWDR = data;                                  //     TWDR

  	  TWCR = (1<<TWINT) | (1<<TWEN);               //      
	                                              // 
	   while (!(TWCR & (1<<TWINT))) ;               //    TWINT   TWCR.
	    return 0;

}


 void  WriteByte(uint8_t reg_3, uint8_t reg_4, uint8_t date) //  ,   : WriteByte (page[k], reg_a[k], date_1[k]); 

{ 
 
	i2cStart();                        //	

	  i2cByteSend(SAddr);                //  
	    
		 i2cByteSend(0x01);                 //  -        
	  
		  i2cByteSend(reg_3);                //    
	
	      i2cStop();                            // 	
	
	i2cStart();                        // 
	
	   i2cByteSend(SAddr);                //   	  

		 i2cByteSend(reg_4);                //  -        
	
	       i2cByteSend(date);                 //   
	
          i2cStop();  

}

/******************** Init TWI (I2C)   *******************************************/

void i2cInit()
{
	TWBR = 92;	                                         //   					
	TWSR = 0;
	TWDR = 0xFF;
	PRR = 0;
}

#endif 

