#ifndef SI5340A_H
#define SI5340A_H

#include <inttypes.h>

#define M_NUM	          0X35			    
#define M_DEN	          0X3B
#define N0_NUM	          0X02			    
#define N0_DEN	          0X08
#define N2_NUM	          0X18			     
#define N2_DEN	          0X1E


#define XTAL_FREQ	80000000			     // Crystal frequency ( 80000000)

#include <inttypes.h>
#include "i2c.h"
 
#include <util/delay.h>

char BufNumPLL[6], BufNumMult[6], BufDenomPLL[4], BufDenomMult[4];

	 void setupPLL(uint64_t, uint32_t);
	   void send(uint8_t, uint8_t, uint8_t, uint64_t, uint64_t);
	    void send_1(uint8_t, uint8_t, uint64_t, uint32_t);
	      //uint8_t i2c_eep_WriteByte(uint8_t, uint8_t);
		    uint8_t  i2cByteSend(uint8_t); 
			 void i2cStop(void);
			   //uint8_t i2c_eep_WriteByte(uint8_t, uint8_t);
			     void  WriteByte(uint8_t, uint8_t, uint8_t);
				   void  WriteByte_1(char, char);
				    void  WriteNUM(uint8_t, uint64_t, char);
					  void  WriteDEN(uint8_t, uint32_t, char);
 
uint8_t page[]=  {0x00,0x00,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x02,0x03,0x09,0x09,0x09,0x0A,0x0A,0x0A,0x0B,0x0B};
uint8_t reg_a[]= {0x18,0x21,0x02,0x12,0x13,0x14,0x15,0x17,0x18,0x19,0x1A,0x26,0x27,0x28,0x29,0x2B,0x2C,0x2D,0x2E,0x06,0x39,0x0E,0x1C,0x43,0x03,0x04,0x05,0x44,0x4A};
uint8_t date_1[]={0x0F,0x07,0x01,0x01,0x01,0x3E,0x08,0x01,0x09,0x3B,0x28,0x02,0x09,0x3B,0x08,0x01,0x09,0x3B,0x28,0x00,0x1F,0x03,0x04,0x01,0x01,0x01,0x01,0xF,0x0E};

/**********************  Si5340A  ********************************/
   void init_Si5340A(void)
   {   
  	char k;	
	  for (k=0; k<29; k++)	
	    WriteByte (page[k], reg_a[k], date_1[k]); 	
   }

   /**********************      PLL Si5340A ********************************/

  	 void setupPLL(uint64_t m_num, uint32_t m_denom)

    {
   volatile  uint64_t P3;					  // PLL config register P1   
    volatile uint32_t P4;					  // PLL config register P2
	
	    P3 = m_num;                           //  p1, p2. 	
	     P4 = m_denom;

		   WriteNUM (0x02, P3, 0x35 );
		    WriteDEN (0x02, P4, 0x3B );

	}

/**********************      PLL Si5340A ********************************/

  	 void setup_div(uint64_t num, uint32_t denom)

    {
   volatile  uint64_t P1;					// PLL config register P1   
    volatile uint32_t P2;					// PLL config register P2
	
	    P1 = num;                           //  p1, p2. 	
	     P2 = denom;

		   WriteNUM (0x03, P1, 0x02);
		    WriteDEN (0x03, P2, 0x08);
   }


/*********************  Num  ************************/

void  WriteNUM (uint8_t page_1, volatile  uint64_t P1, char reg)

 {
 WriteByte_1 (page_1, reg); 

   i2cByteSend ((P1 & 0x00000000000000FF)); 

     i2cByteSend ((P1 & 0x000000000000FF00)>>8);

       i2cByteSend ((P1 & 0x0000000000FF0000)>>16);

	     i2cByteSend ((P1 & 0x00000000FF000000)>>24);

	       i2cByteSend ((P1 & 0x000000FF00000000)>>32);

             i2cByteSend ((P1 & 0x0000FF0000000000)>>40);	   	
                  
	
                          i2cStop();
  }

 /*********************  Denom  ************************/

 void  WriteDEN (uint8_t page_1, volatile  uint32_t P2, char reg)
      {
WriteByte_1 (page_1, reg); 

   i2cByteSend ((P2 & 0x00000000000000FF)); 

     i2cByteSend ((P2 & 0x000000000000FF00)>>8);

       i2cByteSend ((P2 & 0x0000000000FF0000)>>16);

	     i2cByteSend ((P2 & 0x00000000FF000000)>>24);	       
	
                          i2cStop();
	 }

 void  WriteByte_1 (char reg_3, char reg_4) //  ,   : WriteByte (page[k], reg_a[k], date_1[k]); 

{
	i2cStart();                                    //	

	  i2cByteSend(SAddr);                          //  

	     i2cByteSend(0x01);                        //  -        

	       i2cByteSend(reg_3);                     //    
	
	        i2cStop();                             // 	
	
	i2cStart();                                    // 
	
	   i2cByteSend(SAddr);                         //  
		
	    i2cByteSend(reg_4);                       //  -        
	
}

/****************************    VFO  *****************************************/


void si5340aSetFrequency(uint64_t freq, uint16_t r) //    frequensy -      main.
{
   freq = freq*r;

	uint64_t pllFreq=13200000000;                     // : pllFreq, XTALFreq, l, f, mult, num, denom, divider
	  uint32_t xtalFreq = XTAL_FREQ;
	   //uint64_t l;
	    //float f;
	     //volatile uint64_t mult;
	      volatile uint32_t num;
           volatile uint32_t denom;
	        volatile uint64_t divider;
			 volatile uint32_t m_num;
               volatile uint32_t m_denom  = 1048575;
	
	
   divider = pllFreq/xtalFreq;                   //   .  PLL frequency: 13200 MHz
	if ((divider & 1) != 0) divider--;		// Ensure an even integer division ratio (  ,   )

	  pllFreq = divider * xtalFreq;	// Calculate the pllFrequency: the divider * desired output frequency

     //pllFreq = 13200000000;

	//mult = pllFreq / z;		        // Determine the multiplier to get to the required pllFrequency
	 //l = pllFreq % z;			        // It has three parts (   ).
	  //f = l;							// mult is an integer that must be in the range 15..90
	   //f *= 2147483648;				// num and denom are the fractional parts, the numerator and denominator
	   // f /= z;					    // each is 20 bits (range 0..1048575)
	    // num = f;						// the actual multiplier is  mult + num / denom
	       denom = 1048575;		    // For simplicity we set the denominator to the maximum 4294967295

		    //num=(pllFreq/z)*denom;

	//m_num = (uint32_t) ( m_denom*((float)pllFreq/(float)xtalFreq));

		m_num = (uint32_t) ( m_denom*divider);

		  num = (uint32_t) ( denom*((float)pllFreq/(float)freq));      

			   

			     //denom = 4294967295;				//     32 .
				   denom = 1048575; 

	
	setup_div(num, denom);

	 WriteByte (0x03, 0x0C, 0x01);      // Update N0
		
	   setupPLL(m_num, m_denom);

	     WriteByte (0x02, 0x3F, 0x01);      // Update M

		   WriteDEN (0x02, 2, 0x5C);

	    
	
}

	    
#endif 
